<?php
class ControllerShippingPostaPont extends Controller {
	private $error = array(); 

	public function index() {   
		$this->load->language('shipping/postapont');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$postapont_posta_costs = array();
			$postapont_posta_cost  = $this->request->post['postapont_posta_cost'];
			unset($this->request->post['postapont_posta_cost']);
			foreach($postapont_posta_cost as $k=>$v) {
					$postapont_posta_costs[] = $k.':'.$v;
			}
			$this->request->post['postapont_posta_cost'] = implode(',', $postapont_posta_costs);

			$postapont_mol_costs = array();
			$postapont_mol_cost  = $this->request->post['postapont_mol_cost'];
			unset($this->request->post['postapont_mol_cost']);
			foreach($postapont_mol_cost as $k=>$v) {
					$postapont_mol_costs[] = $k.':'.$v;
			}
			$this->request->post['postapont_mol_cost'] = implode(',', $postapont_mol_costs);

			$postapont_coop_costs = array();
			$postapont_coop_cost  = $this->request->post['postapont_coop_cost'];
			unset($this->request->post['postapont_coop_cost']);
			foreach($postapont_coop_cost as $k=>$v) {
					$postapont_coop_costs[] = $k.':'.$v;
			}
			$this->request->post['postapont_coop_cost'] = implode(',', $postapont_coop_costs);
			
			$postapont_media_costs = array();
			$postapont_media_cost  = $this->request->post['postapont_media_cost'];
			unset($this->request->post['postapont_media_cost']);
			foreach($postapont_media_cost as $k=>$v) {
					$postapont_media_costs[] = $k.':'.$v;
			}
			$this->request->post['postapont_media_cost'] = implode(',', $postapont_media_costs);
			
			$postapont_automata_costs = array();
			$postapont_automata_cost  = $this->request->post['postapont_automata_cost'];
			unset($this->request->post['postapont_automata_cost']);
			foreach($postapont_automata_cost as $k=>$v) {
					$postapont_automata_costs[] = $k.':'.$v;
			}
			$this->request->post['postapont_automata_cost'] = implode(',', $postapont_automata_costs);

			$this->model_setting_setting->editSetting('postapont', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_license'] = $this->language->get('text_license');
		$data['text_postapont'] = $this->language->get('text_postapont');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');
		$data['label_api_key'] = $this->language->get('label_api_key');
		
		$data['entry_cost'] = $this->language->get('entry_cost');
		$data['entry_free_total'] = $this->language->get('entry_free_total');
		$data['entry_free_total_help'] = $this->language->get('entry_free_total_help');
		$data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_google_maps_api_key'] = $this->language->get('entry_google_maps_api_key');
		$data['google_maps_api_key_help'] = $this->language->get('google_maps_api_key_help');
		$data['entry_status_postapont'] = $this->language->get('entry_status_postapont');
		$data['entry_status_mol'] = $this->language->get('entry_status_mol');
		$data['entry_status_coop'] = $this->language->get('entry_status_coop');
		$data['entry_status_media'] = $this->language->get('entry_status_media');
		$data['entry_status_automata'] = $this->language->get('entry_status_automata');
		$data['entry_only_post_office'] = $this->language->get('entry_only_post_office');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_shipping'),
			'href'      => $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('shipping/postapont', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['action'] = $this->url->link('shipping/postapont', 'token=' . $this->session->data['token'], 'SSL');

		$data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->post['postapont_license_key'])) {
			$data['postapont_license_key'] = $this->request->post['postapont_license_key'];
		} else {
			$data['postapont_license_key'] = $this->config->get('postapont_license_key');
		}
		
		
		if (isset($this->request->post['postapont_posta_cost'])) {
			$postapont_posta_costs = explode(',', $this->request->post['postapont_posta_cost']);
			foreach($postapont_posta_costs as $value) {
				$datas = explode(':', $value);
				$data['postapont_posta_cost'][$datas[0]] = $datas[1];
			}
		} else {
			$data['postapont_posta_cost'] = array(
				 1 => '',
				 2 => '',
				 3 => '',
				 4 => '',
				 5 => '',
				10 => '',
				15 => '',
				20 => '',
				30 => ''
			);
			$postapont_posta_costs = explode(',', $this->config->get('postapont_posta_cost'));
			if (!empty($postapont_posta_costs) && count($postapont_posta_costs)>1) {
				foreach($postapont_posta_costs as $value) {
					$datas = explode(':', $value);
					$data['postapont_posta_cost'][$datas[0]] = $datas[1];
				}
			}
		}
		
		if (isset($this->request->post['postapont_mol_cost'])) {
			$postapont_mol_costs = explode(',', $this->request->post['postapont_mol_cost']);
			foreach($postapont_mol_costs as $value) {
				$datas = explode(':', $value);
				$data['postapont_mol_cost'][$datas[0]] = $datas[1];
			}
		} else {
			$data['postapont_mol_cost'] = array(
				 1 => '',
				 2 => '',
				 3 => '',
				 4 => '',
				 5 => '',
				10 => '',
				15 => '',
				20 => ''
			);
			$postapont_mol_costs = explode(',', $this->config->get('postapont_mol_cost'));
			if (!empty($postapont_mol_costs) && count($postapont_mol_costs)>1) {
				foreach($postapont_mol_costs as $value) {
					$datas = explode(':', $value);
					$data['postapont_mol_cost'][$datas[0]] = $datas[1];
				}
			}
		}		

		if (isset($this->request->post['postapont_coop_cost'])) {
			$postapont_coop_costs = explode(',', $this->request->post['postapont_coop_cost']);
			foreach($postapont_coop_costs as $value) {
				$datas = explode(':', $value);
				$data['postapont_coop_cost'][$datas[0]] = $datas[1];
			}
		} else {
			$data['postapont_coop_cost'] = array(
				 1 => '',
				 2 => '',
				 3 => '',
				 4 => '',
				 5 => '',
				10 => '',
				15 => '',
				20 => ''
			);
			$postapont_coop_costs = explode(',', $this->config->get('postapont_coop_cost'));
			if (!empty($postapont_coop_costs) && count($postapont_coop_costs)>1) {
				foreach($postapont_coop_costs as $value) {
					$datas = explode(':', $value);
					$data['postapont_coop_cost'][$datas[0]] = $datas[1];
				}
			}
		}

		if (isset($this->request->post['postapont_media_cost'])) {
			$postapont_media_costs = explode(',', $this->request->post['postapont_media_cost']);
			foreach($postapont_media_costs as $value) {
				$datas = explode(':', $value);
				$data['postapont_media_cost'][$datas[0]] = $datas[1];
			}
		} else {
			$data['postapont_media_cost'] = array(
				 1 => '',
				 2 => '',
				 3 => '',
				 4 => '',
				 5 => '',
				10 => '',
				15 => '',
				20 => ''
			);
			$postapont_media_costs = explode(',', $this->config->get('postapont_media_cost'));
			if (!empty($postapont_media_costs) && count($postapont_media_costs)>1) {
				foreach($postapont_media_costs as $value) {
					$datas = explode(':', $value);
					$data['postapont_media_cost'][$datas[0]] = $datas[1];
				}
			}
		}

		if (isset($this->request->post['postapont_automata_cost'])) {
			$postapont_automata_costs = explode(',', $this->request->post['postapont_automata_cost']);
			foreach($postapont_automata_costs as $value) {
				$datas = explode(':', $value);
				$data['postapont_automata_cost'][$datas[0]] = $datas[1];
			}
		} else {
			$data['postapont_automata_cost'] = array(
				 1 => '',
				 2 => '',
				 3 => '',
				 4 => '',
				 5 => '',
				10 => '',
				15 => '',
				20 => ''
			);
			$postapont_automata_costs = explode(',', $this->config->get('postapont_automata_cost'));
			if (!empty($postapont_automata_costs) && count($postapont_automata_costs)>1) {
				foreach($postapont_automata_costs as $value) {
					$datas = explode(':', $value);
					$data['postapont_automata_cost'][$datas[0]] = $datas[1];
				}
			}
		}
		

		
		if (isset($this->request->post['postapont_free_total'])) {
			$data['postapont_free_total'] = $this->request->post['postapont_free_total'];
		} else {
			$data['postapont_free_total'] = $this->config->get('postapont_free_total');
		}

		if (isset($this->request->post['postapont_tax_class_id'])) {
			$data['postapont_tax_class_id'] = $this->request->post['postapont_tax_class_id'];
		} else {
			$data['postapont_tax_class_id'] = $this->config->get('postapont_tax_class_id');
		}

		$this->load->model('localisation/tax_class');

		$data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

		if (isset($this->request->post['postapont_geo_zone_id'])) {
			$data['postapont_geo_zone_id'] = $this->request->post['postapont_geo_zone_id'];
		} else {
			$data['postapont_geo_zone_id'] = $this->config->get('postapont_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['postapont_status'])) {
			$data['postapont_status'] = $this->request->post['postapont_status'];
		} else {
			$data['postapont_status'] = $this->config->get('postapont_status');
		}
		
		if (isset($this->request->post['postapont_status_postapont'])) {
			$data['postapont_status_postapont'] = $this->request->post['postapont_status_postapont'];
		} else {
			$data['postapont_status_postapont'] = $this->config->get('postapont_status_postapont');
		}
		if (isset($this->request->post['postapont_mol_status'])) {
			$data['postapont_mol_status'] = $this->request->post['postapont_mol_status'];
		} else {
			$data['postapont_mol_status'] = $this->config->get('postapont_mol_status');
		}
		if (isset($this->request->post['postapont_coop_status'])) {
			$data['postapont_coop_status'] = $this->request->post['postapont_coop_status'];
		} else {
			$data['postapont_coop_status'] = $this->config->get('postapont_coop_status');
		}
		if (isset($this->request->post['postapont_media_status'])) {
			$data['postapont_media_status'] = $this->request->post['postapont_media_status'];
		} else {
			$data['postapont_media_status'] = $this->config->get('postapont_media_status');
		}
		if (isset($this->request->post['postapont_automata_status'])) {
			$data['postapont_automata_status'] = $this->request->post['postapont_automata_status'];
		} else {
			$data['postapont_automata_status'] = $this->config->get('postapont_automata_status');
		}

		if (isset($this->request->post['postapont_sort_order'])) {
			$data['postapont_sort_order'] = $this->request->post['postapont_sort_order'];
		} else {
			$data['postapont_sort_order'] = $this->config->get('postapont_sort_order');
		}
		
		if (isset($this->request->post['postapont_google_maps_api_key'])) {
			$data['postapont_google_maps_api_key'] = $this->request->post['postapont_google_maps_api_key'];
		} else {
			$data['postapont_google_maps_api_key'] = $this->config->get('postapont_google_maps_api_key');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		//echo "<pre>";print_r($data);exit;
		$this->response->setOutput($this->load->view('shipping/postapont.tpl', $data));
	}

	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/postapont')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}
?>