<?php
class ModelShippingPostaPont extends Model {
	public function getQuote($address) {
		$this->load->language('shipping/postapont');
		$method_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('postapont_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		if (!$this->config->get('postapont_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}
		$link = "https://next-it.eu/api.php?modul=postapont&domain=".$_SERVER['SERVER_NAME']."&key=".trim($this->config->get('postapont_license_key'));
		$URL = file_get_contents($link);
		//print_r($URL);exit;
		if($URL == "error") {
			$status = false;
		}
		else {
			$weight = $this->cart->getWeight();

			if($weight>30) {
				$status = false;
			}

			if ($status) {
				$quote_data = array();
				$free = false;

				if ($this->config->get('postapont_free_total')!='' && $this->cart->getSubTotal() >= $this->config->get('postapont_free_total')) {
					$free = true;
				}
				$cost_by_group['10_posta'] = 0;
				$cost_by_group['20_molkut'] = 0;
				$cost_by_group['30_csomagautomata'] = 0;
				$cost_by_group['40_postapontplusz'] = 0;
				$cost_by_group['50_coop'] = 0;
				$cost_by_group['70_mediamarkt'] = 0;
				
				if ($free) {

				} else {
					
					$rates['posta'] = explode(',', $this->config->get('postapont_posta_cost'));
					$rates['mol'] = explode(',', $this->config->get('postapont_mol_cost'));
					$rates['coop'] = explode(',', $this->config->get('postapont_coop_cost'));
					$rates['mediamarkt'] = explode(',', $this->config->get('postapont_media_cost'));
					$rates['automata'] = explode(',', $this->config->get('postapont_automata_cost'));
					//echo "<pre>";print_r($rates);exit;
					$cost = 0;

					$actualRateKey = 0;
					foreach ($rates['posta'] as $rateKey=>$rate) {
						$data = explode(':', $rate);

						if ($data[0] >= $weight) {
							if (isset($data[1])) {
								$cost = $data[1];
								$cost_by_group['10_posta'] = $data[1];
								$cost_by_group['40_postapontplusz'] = $data[1];
								$actualRateKey = $rateKey;
							}
							break;
						}
					}
					if ($weight>=20) {
						$rates['mol'][$actualRateKey] = $rates['posta'][$actualRateKey];
						$rates['coop'][$actualRateKey] = $rates['posta'][$actualRateKey];
						$rates['mediamarkt'][$actualRateKey] = $rates['posta'][$actualRateKey];
						$rates['automata'][$actualRateKey] = $rates['posta'][$actualRateKey];
					}
					//echo $actualRRateKey."-<br>";
					$mol_cost = explode(':', $rates['mol'][$actualRateKey]);
					$coop_cost = explode(':', $rates['coop'][$actualRateKey]);
					$media_cost = explode(':', $rates['mediamarkt'][$actualRateKey]);
					$automata_cost = explode(':', $rates['automata'][$actualRateKey]);
					$cost_by_group['20_molkut'] = $mol_cost[1];
					$cost_by_group['30_csomagautomata'] = $automata_cost[1];
					$cost_by_group['50_coop'] = $coop_cost[1];
					$cost_by_group['70_mediamarkt'] = $media_cost[1];
				}
				$this->session->data['postapont_cost_by_group'] = $cost_by_group;
				$content = $this->language->get('text_title');
				if ($_GET['route'] == 'checkout/shipping_method') {
					$content = file_get_contents(DIR_TEMPLATE."/default/template/shipping/postapont.tpl");
					if($weight>=20) {
						$content = str_replace(
							array(
							  '[GOOGELMAPSAPIKEY]',
							  '[DISABLE_POSTAPONT]',
							  '[DISABLE_MOL]',
							  '[DISABLE_AUTOMATA]',
							  '[DISABLE_COOP]',
							  '[DISABLE_MEDIA]',
							  '[POSTA_COST]',
							  '[POSTA_COST_TEXT]',
							  '[MOL_COST]',
							  '[MOL_COST_TEXT]',
							  '[COOP_MEDIA]',
							  '[COOP_MEDIA_TEXT]',
							  '[COOP_COST]',
							  '[COOP_COST_TEXT]',
							  '[AUTOMATA_COST]',
							  '[AUTOMATA_COST_TEXT]'
							),
							array(
								($this->config->get('postapont_google_maps_api_key')?'&key='.$this->config->get('postapont_google_maps_api_key'):''),
								($this->config->get('postapont_status_postapont')?'':"ppapi.setMarkers('10_posta', false);"),
								"ppapi.setMarkers('20_molkut', false);",
								"ppapi.setMarkers('30_csomagautomata', false);",
								"ppapi.setMarkers('50_coop', false);",
								"ppapi.setMarkers('70_mediamarkt', false);",
								$cost_by_group['10_posta'],
								$this->currency->format($this->tax->calculate($cost_by_group['10_posta'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['20_molkut'],
								$this->currency->format($this->tax->calculate($cost_by_group['20_molkut'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['50_coop'],
								$this->currency->format($this->tax->calculate($cost_by_group['50_coop'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['70_mediamarkt'],
								$this->currency->format($this->tax->calculate($cost_by_group['70_mediamarkt'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['30_csomagautomata'],
								$this->currency->format($this->tax->calculate($cost_by_group['30_csomagautomata'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
							),
							$content
						);
					}
					else {
						$content = str_replace(
							array(
							  '[GOOGELMAPSAPIKEY]',
							  '[DISABLE_POSTAPONT]',
							  '[DISABLE_MOL]',
							  '[DISABLE_AUTOMATA]',
							  '[DISABLE_COOP]',
							  '[DISABLE_MEDIA]',
							  '[POSTA_COST]',
							  '[POSTA_COST_TEXT]',
							  '[MOL_COST]',
							  '[MOL_COST_TEXT]',
							  '[COOP_COST]',
							  '[COOP_COST_TEXT]',
							  '[MEDIA_COST]',
							  '[MEDIA_COST_TEXT]',
							  '[AUTOMATA_COST]',
							  '[AUTOMATA_COST_TEXT]'
							),
							array(
								($this->config->get('postapont_google_maps_api_key')?'&key='.$this->config->get('postapont_google_maps_api_key'):''),
								($this->config->get('postapont_status_postapont')?'':"ppapi.setMarkers('10_posta', false);"),
								($this->config->get('postapont_mol_status')?'':"ppapi.setMarkers('20_molkut', false);"),
								($this->config->get('postapont_automata_status')?'':"ppapi.setMarkers('30_csomagautomata', false);"),
								($this->config->get('postapont_coop_status')?'':"ppapi.setMarkers('50_coop', false);"),
								($this->config->get('postapont_media_status')?'':"ppapi.setMarkers('70_mediamarkt', false);"),
								$cost_by_group['10_posta'],
								$this->currency->format($this->tax->calculate($cost_by_group['10_posta'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['20_molkut'],
								$this->currency->format($this->tax->calculate($cost_by_group['20_molkut'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['50_coop'],
								$this->currency->format($this->tax->calculate($cost_by_group['50_coop'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['70_mediamarkt'],
								$this->currency->format($this->tax->calculate($cost_by_group['70_mediamarkt'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']),
								$cost_by_group['30_csomagautomata'],
								$this->currency->format($this->tax->calculate($cost_by_group['30_csomagautomata'], $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
							),
							$content
						);
					}
				}

				if ($free) {
					$quote_data['postapont'] = array(
						'code'         => 'postapont.postapont',
						'title'        => $content . '  (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class_id')) . ')',
						'cost'         => 0.00,
						'tax_class_id' => 0,
						'text'         => $this->currency->format($this->tax->calculate(0.00, $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
				} else {
					
					$rates['posta'] = explode(',', $this->config->get('postapont_posta_cost'));
					$cost = 0;

					foreach ($rates['posta'] as $rateKey=>$rate) {
						$data = explode(':', $rate);

						if ($data[0] >= $weight) {
							if (isset($data[1])) {
								$cost = $data[1];
							}
							break;
						}
					}
					
					//if ((int)$cost>0) {
					$quote_data['postapont'] = array(
						'code'         => 'postapont.postapont',
						'title'        => $content . '  (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class_id')) . ')',
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('postapont_tax_class_id'),
						'text'         => '<div id="postaPontCostText">'.$this->currency->format($this->tax->calculate($cost, $this->config->get('postapont_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency']).'</div>'
					);
					//}
				}				
				if ($quote_data) {
					$method_data = array(
						'code'       => 'postapont',
						'title'      => $this->language->get('text_title'),
						'quote'      => $quote_data,
						'sort_order' => $this->config->get('postapont_sort_order'),
						'error'      => false
					);
				}
			}
		}
		return $method_data;
	}
}
?>